Attribute VB_Name = "VertexModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Public vxSkyBox() As D3DLVERTEX

Const SkyBox As Single = 2000
Const SkyBoxTU As Single = 3
Const SkyBoxTV As Single = 3

Public Sub SetVertex()
    Dim i As Integer
    On Error GoTo ErrOut
    ReDim vxSkyBox(35)
    CreateSkyBox 0
    For i = 0 To UBound(BOXEN())
        CreateBox 20, 20, 20, BOXEN(i).vxBox()
        With BOXEN(i).Mittelpunkt
            .x = -10: .y = -10: .z = -10
        End With
    Next
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub

Public Sub CreateBox(ByVal boxHeight As Single, ByVal boxWidth As Single, ByVal boxDepth As Single, ByRef vxArray() As D3DLVERTEX)
    Dim color As Long
    On Error GoTo ErrOut
    color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
    DX7.CreateD3DLVertex 0, boxHeight, 0, color, color, 0, 0, vxArray(0)
    DX7.CreateD3DLVertex boxWidth, 0, 0, color, color, 1, 1, vxArray(1)
    DX7.CreateD3DLVertex 0, 0, 0, color, color, 0, 1, vxArray(2)
    DX7.CreateD3DLVertex 0, boxHeight, 0, color, color, 0, 0, vxArray(3)
    DX7.CreateD3DLVertex boxWidth, boxHeight, 0, color, color, 1, 0, vxArray(4)
    DX7.CreateD3DLVertex boxWidth, 0, 0, color, color, 1, 1, vxArray(5)
    
    DX7.CreateD3DLVertex boxWidth, boxHeight, 0, color, color, 0, 0, vxArray(6)
    DX7.CreateD3DLVertex boxWidth, 0, boxDepth, color, color, 1, 1, vxArray(7)
    DX7.CreateD3DLVertex boxWidth, 0, 0, color, color, 0, 1, vxArray(8)
    DX7.CreateD3DLVertex boxWidth, boxHeight, 0, color, color, 0, 0, vxArray(9)
    DX7.CreateD3DLVertex boxWidth, boxHeight, boxDepth, color, color, 1, 0, vxArray(10)
    DX7.CreateD3DLVertex boxWidth, 0, boxDepth, color, color, 1, 1, vxArray(11)
    
    DX7.CreateD3DLVertex boxWidth, boxHeight, boxDepth, color, color, 0, 0, vxArray(12)
    DX7.CreateD3DLVertex 0, 0, boxDepth, color, color, 1, 1, vxArray(13)
    DX7.CreateD3DLVertex boxWidth, 0, boxDepth, color, color, 0, 1, vxArray(14)
    DX7.CreateD3DLVertex boxWidth, boxHeight, boxDepth, color, color, 0, 0, vxArray(15)
    DX7.CreateD3DLVertex 0, boxHeight, boxDepth, color, color, 1, 0, vxArray(16)
    DX7.CreateD3DLVertex 0, 0, boxDepth, color, color, 1, 1, vxArray(17)
    
    DX7.CreateD3DLVertex 0, boxHeight, boxDepth, color, color, 0, 0, vxArray(18)
    DX7.CreateD3DLVertex 0, 0, 0, color, color, 1, 1, vxArray(19)
    DX7.CreateD3DLVertex 0, 0, boxDepth, color, color, 0, 1, vxArray(20)
    DX7.CreateD3DLVertex 0, boxHeight, boxDepth, color, color, 0, 0, vxArray(21)
    DX7.CreateD3DLVertex 0, boxHeight, 0, color, color, 1, 0, vxArray(22)
    DX7.CreateD3DLVertex 0, 0, 0, color, color, 1, 1, vxArray(23)
    
    DX7.CreateD3DLVertex 0, boxHeight, boxDepth, color, color, 0, 0, vxArray(24)
    DX7.CreateD3DLVertex boxWidth, boxHeight, 0, color, color, 1, 1, vxArray(25)
    DX7.CreateD3DLVertex 0, boxHeight, 0, color, color, 0, 1, vxArray(26)
    DX7.CreateD3DLVertex 0, boxHeight, boxDepth, color, color, 0, 0, vxArray(27)
    DX7.CreateD3DLVertex boxWidth, boxHeight, boxDepth, color, color, 1, 0, vxArray(28)
    DX7.CreateD3DLVertex boxWidth, boxHeight, 0, color, color, 1, 1, vxArray(29)
    
    DX7.CreateD3DLVertex 0, 0, 0, color, color, 0, 0, vxArray(30)
    DX7.CreateD3DLVertex boxWidth, 0, boxDepth, color, color, 1, 1, vxArray(31)
    DX7.CreateD3DLVertex 0, 0, boxDepth, color, color, 0, 1, vxArray(32)
    DX7.CreateD3DLVertex 0, 0, 0, color, color, 0, 0, vxArray(33)
    DX7.CreateD3DLVertex boxWidth, 0, 0, color, color, 1, 0, vxArray(34)
    DX7.CreateD3DLVertex boxWidth, 0, boxDepth, color, color, 1, 1, vxArray(35)
    
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub

Public Sub CreateSkyBox(ByVal StartVertex As Integer)
    Dim color As Long
    On Error GoTo ErrOut
    color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
    'SkyBox Seite 1
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, SkyBox / 2, color, color, 0, 0, vxSkyBox(StartVertex)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), SkyBox / 2, color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 1)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), SkyBox / 2, color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 2)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, SkyBox / 2, color, color, 0, 0, vxSkyBox(StartVertex + 3)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, SkyBox / 2, color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 4)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), SkyBox / 2, color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 5)
    'SkyBox Seite 2
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, SkyBox / 2, color, color, 0, 0, vxSkyBox(StartVertex + 6)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 7)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), SkyBox / 2, color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 8)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, SkyBox / 2, color, color, 0, 0, vxSkyBox(StartVertex + 9)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, -1 * (SkyBox / 2), color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 10)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 11)
    'SkyBox Seite 3
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, -1 * (SkyBox / 2), color, color, 0, 0, vxSkyBox(StartVertex + 12)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 13)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 14)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, -1 * (SkyBox / 2), color, color, 0, 0, vxSkyBox(StartVertex + 15)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, -1 * (SkyBox / 2), color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 16)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 17)
    'SkyBox Seite 4
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, -1 * (SkyBox / 2), color, color, 0, 0, vxSkyBox(StartVertex + 18)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), SkyBox / 2, color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 19)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 20)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, -1 * (SkyBox / 2), color, color, 0, 0, vxSkyBox(StartVertex + 21)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, SkyBox / 2, color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 22)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), SkyBox / 2, color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 23)
    'SkyBox Unten
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), SkyBox / 2, color, color, 0, 0, vxSkyBox(StartVertex + 24)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 25)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 26)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), -1 * (SkyBox / 2), SkyBox / 2, color, color, 0, 0, vxSkyBox(StartVertex + 27)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), SkyBox / 2, color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 28)
    DX7.CreateD3DLVertex SkyBox / 2, -1 * (SkyBox / 2), -1 * (SkyBox / 2), color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 29)
    'SkyBox Oben
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, SkyBox / 2, color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 30)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, -1 * (SkyBox / 2), color, color, 0, 0, vxSkyBox(StartVertex + 31)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, -1 * (SkyBox / 2), color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 32)
    DX7.CreateD3DLVertex -1 * (SkyBox / 2), SkyBox / 2, SkyBox / 2, color, color, 0, SkyBoxTV, vxSkyBox(StartVertex + 33)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, -1 * (SkyBox / 2), color, color, SkyBoxTU, 0, vxSkyBox(StartVertex + 34)
    DX7.CreateD3DLVertex SkyBox / 2, SkyBox / 2, SkyBox / 2, color, color, SkyBoxTU, SkyBoxTV, vxSkyBox(StartVertex + 35)
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub
